package steps

// |@@| F

import (
	"context"
	"gardening/src/dat/maes"
	"gardening/src/lib/error"
	"gardening/src/lib/maestro"
	"gardening/src/srv/fetchers"
	"gardening/src/srv/handlers"
	"gardening/src/srv/molders"
)

type SaveEntityStep struct {
	Maestro                   *maestro.Maestro
	PlantTaskFetcher          *fetchers.PlantTaskFetcher
	PlantTaskHandler          *handlers.PlantTaskHandler
	UpdatePlantTaskFormMolder *molders.UpdatePlantTaskFormMolder
}

func (this *SaveEntityStep) Act(ctx context.Context, in *maes.UpdatePlantTaskMaeIn, out *maes.UpdatePlantTaskMaeOut) (bool, error) {
	var err error
	entity, has, err := this.PlantTaskFetcher.FindOneById(ctx, in.Request.Form.Id, nil)
	if err != nil {
		return false, err
	}
	if !has {
		return false, erro.N("No entity found")
	}
	entity, fields := this.UpdatePlantTaskFormMolder.ToEntity(&in.Request.Form, entity)
	out.Response.PlantTask, err = this.PlantTaskHandler.UpdateFields(ctx, entity, fields, nil)
	if err != nil {
		return false, err
	}
	this.Maestro.AddSuccessMessage(&out.Extra, "Plant Task updated")
	return true, nil
}
